import 'dart:async';

import 'package:flutter/services.dart';

//BasicMessageChannel
class WitsystemDevicePlugin {
  static const MethodChannel _channel =
      MethodChannel('witsystem_flutter_device_plugin');
  static const BasicMessageChannel _basicChannel = BasicMessageChannel(
      'witsystem_device_plugin_basicmessagechannel', StandardMessageCodec());

  static const EventChannel eventChannel= EventChannel("name");

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  /// 初始化SDK
  static Future<bool> initSDK(
      String appId, token, appSecret, rsaPrivateKey) async {
    final map = {
      "appId": appId,
      "token": token,
      "appSecret": appSecret,
      "rsaPrivateKey": rsaPrivateKey
    };
    return await _channel.invokeMethod("initSDK", map);
  }

  /// 开启设备
  /// deviceId 可以为空，为空代表开启附近设备
  static Future<Map> bleUnlock({String? deviceId}) async {
    // final map = {"deviceId": deviceId};
    // _channel.setMethodCallHandler(handler);
    //return await _channel.invokeMethod("bleUnlock", map);

    StreamController streamController = StreamController<String>.broadcast(onListen: () => {

      print("启动监听")

    },onCancel: ()=>{
    print("关闭")
    });

    streamController.stream.listen((event) {
      print("监听事件event"+event.toString());
    },onDone: (){
      print("onDone关闭");
    },onError: (err){
      print("异常"+err);
    });
    streamController.addStream(eventChannel.receiveBroadcastStream());
    streamController.sink.addError("错误");
    streamController.sink.add("jjjj");
    streamController.close();
    return Future.value({});
  }

  ///扫描可以添加设备
  static void scanAddBleDevice() {
    //_basicChannel.setMessageHandler((message) => null)
    _basicChannel.send("scanAddBleDevice");
  }

  static Future<bool> handler(MethodCall call) async {
    return true;
  }
}
